"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const react_ada_datepicker_1 = (0, tslib_1.__importStar)(require("react-ada-datepicker"));
const DateTimePicker_nls_1 = require("./DateTimePicker.nls");
const includes_1 = (0, tslib_1.__importDefault)(require("lodash/includes"));
const en_GB_1 = (0, tslib_1.__importDefault)(require("date-fns/locale/en-GB"));
const sv_1 = (0, tslib_1.__importDefault)(require("date-fns/locale/sv"));
const nb_1 = (0, tslib_1.__importDefault)(require("date-fns/locale/nb"));
const nn_1 = (0, tslib_1.__importDefault)(require("date-fns/locale/nn"));
const DateTimeInput_1 = (0, tslib_1.__importDefault)(require("./DateTimeInput"));
const react_overlays_1 = require("react-overlays");
const localeMap = {
    en: en_GB_1.default,
    sv: sv_1.default,
    nb: nb_1.default,
    nn: nn_1.default,
};
const getPortalContainer = (container) => {
    return ({ children }) => (0, jsx_runtime_1.jsx)(react_overlays_1.Portal, Object.assign({ container: container }, { children: children }), void 0);
};
class DateTimePicker extends React.Component {
    constructor(props) {
        super(props);
        this.showTimeSelect = false;
        this.showTimeSelectOnly = false;
        this.currentNls = null;
        this.dateFormatId = "";
        this.timeFormatId = "";
        this.popperContainer = null;
        const { dateFormat, timeFormat, viewMode, locale, portalPopupTo } = this.props;
        (0, react_ada_datepicker_1.registerLocale)(locale, localeMap[locale]);
        this.showTimeSelect = (0, includes_1.default)(["datetime", "time"], viewMode);
        this.showTimeSelectOnly = viewMode === "time";
        this.currentNls = DateTimePicker_nls_1.nls[locale.substr(0, 2)];
        if (dateFormat === undefined) {
            this.dateFormatId = this.currentNls["date"];
        }
        else if (typeof dateFormat === "string") {
            this.dateFormatId = this.currentNls[`longDateFormat_${dateFormat}`];
        }
        if (timeFormat === undefined) {
            this.timeFormatId = this.currentNls["time"];
        }
        else if (typeof timeFormat === "string") {
            this.timeFormatId = this.currentNls[`longDateFormat_${timeFormat}`];
        }
        if (portalPopupTo) {
            this.popperContainer = getPortalContainer(portalPopupTo);
        }
        if (this.showTimeSelectOnly) {
            return;
        }
        if (this.showTimeSelect) {
            this.dateFormatId += ` ${this.timeFormatId}`;
        }
    }
    render() {
        const _a = this.props, { dateFormat, timeFormat, viewMode, disabled, defaultValue, todayButton, inline } = _a, rest = (0, tslib_1.__rest)(_a, ["dateFormat", "timeFormat", "viewMode", "disabled", "defaultValue", "todayButton", "inline"]);
        return ((0, jsx_runtime_1.jsx)(react_ada_datepicker_1.default, Object.assign({}, rest, { todayButton: todayButton ? this.currentNls["todayLbl"] : null, selected: defaultValue, disabled: disabled, showTimeSelect: this.showTimeSelect, showTimeSelectOnly: this.showTimeSelectOnly, dateFormat: this.dateFormatId, timeFormat: this.timeFormatId, timeIntervals: 15, shouldCloseOnSelect: true, customInput: (0, jsx_runtime_1.jsx)(DateTimeInput_1.default, {}, void 0), popperContainer: this.popperContainer, adjustDateOnChange: true, inline: inline }), void 0));
    }
}
exports.default = DateTimePicker;
DateTimePicker.defaultProps = {
    locale: "nb",
};
