"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const prop_types_1 = (0, tslib_1.__importDefault)(require("prop-types"));
const classnames_1 = (0, tslib_1.__importDefault)(require("classnames"));
const lodash_1 = require("lodash");
const Dropdown_1 = (0, tslib_1.__importDefault)(require("./Dropdown"));
class DropdownItem extends React.Component {
    constructor() {
        super(...arguments);
        this.onItemClick = (e) => {
            if (this.props.disabled || this.props.header || this.props.divider) {
                e.preventDefault();
                return;
            }
            if (this.props.onClick) {
                this.props.onClick(e);
            }
            if (this.props.tag !== "select" && this.props.toggle) {
                this.context.toggle(e);
            }
        };
    }
    get role() {
        return this.props.header || this.props.divider ? "presentation" : "menuitem";
    }
    render() {
        const _a = (0, lodash_1.omit)(this.props, ["toggle"]), { className, divider, tag, header, active, innerRef } = _a, props = (0, tslib_1.__rest)(_a, ["className", "divider", "tag", "header", "active", "innerRef"]);
        let Tag = tag;
        const classes = (0, classnames_1.default)(className, {
            disabled: props.disabled,
            "dropdown-item": !divider && !header,
            active: active,
            "dropdown-header": header,
            "dropdown-divider": divider,
        });
        if (Tag === "button") {
            if (header) {
                Tag = "h6";
            }
            else if (divider) {
                Tag = "div";
            }
            else if (props.href) {
                Tag = "a";
            }
        }
        return ((0, jsx_runtime_1.jsx)("li", Object.assign({ role: "presentation" }, { children: this.props.children && this.props.children["type"] === Dropdown_1.default ? (this.props.children) : ((0, jsx_runtime_1.jsx)(Tag, Object.assign({ type: Tag === "button" && (this.props.onClick || this.props.toggle)
                    ? "button"
                    : undefined }, props, { role: this.role, className: classes, onClick: this.onItemClick, ref: innerRef }), void 0)) }), void 0));
    }
}
exports.default = DropdownItem;
DropdownItem.defaultProps = {
    tag: "button",
    toggle: true,
};
DropdownItem.contextTypes = {
    toggle: prop_types_1.default.func,
};
