"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const prop_types_1 = (0, tslib_1.__importDefault)(require("prop-types"));
const classnames_1 = (0, tslib_1.__importDefault)(require("classnames"));
const react_popper_1 = require("react-popper");
const noFlipModifier = { flip: { enabled: false } };
const directionPositionMap = {
    up: "top",
    left: "left",
    right: "right",
    down: "bottom"
};
const DropdownMenu = (props, context) => {
    const { className, right: rightPlacement, tag: Tag = "ul", flip, modifiers, persist } = props, attrs = (0, tslib_1.__rest)(props, ["className", "right", "tag", "flip", "modifiers", "persist"]);
    const classes = (0, classnames_1.default)(className, "dropdown-menu", {
        "dropdown-menu-right": rightPlacement,
        show: context.isOpen
    });
    if (persist || (context.isOpen && !context.inNavbar)) {
        const position1 = directionPositionMap[context.direction] || "bottom";
        const position2 = rightPlacement ? "end" : "start";
        const mods = !flip
            ? Object.assign(Object.assign({}, modifiers), noFlipModifier) : modifiers;
        return ((0, jsx_runtime_1.jsx)(react_popper_1.Popper, Object.assign({ placement: `${position1}-${position2}`, modifiers: mods }, { children: ({ ref, placement }) => {
                return ((0, jsx_runtime_1.jsx)(Tag, Object.assign({ className: classes, ref: ref, role: "menu", "aria-hidden": !context.isOpen, "x-placement": placement }, attrs), void 0));
            } }), void 0));
    }
    return (0, jsx_runtime_1.jsx)(Tag, Object.assign({ tabIndex: "-1", role: "menu" }, attrs, { "aria-hidden": !context.isOpen, className: classes }), void 0);
};
DropdownMenu.defaultProps = {
    tag: "ul",
    flip: true
};
DropdownMenu.contextTypes = {
    isOpen: prop_types_1.default.bool.isRequired,
    direction: prop_types_1.default.oneOf(["up", "down", "left", "right"]).isRequired,
    inNavbar: prop_types_1.default.bool.isRequired
};
exports.default = DropdownMenu;
