"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const prop_types_1 = (0, tslib_1.__importDefault)(require("prop-types"));
const classnames_1 = (0, tslib_1.__importDefault)(require("classnames"));
const react_popper_1 = require("react-popper");
class DropdownToggle extends React.Component {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            const { disabled, nav, tag, onClick } = this.props;
            if (disabled) {
                e.preventDefault();
                return;
            }
            if (nav && !tag) {
                e.preventDefault();
            }
            onClick === null || onClick === void 0 ? void 0 : onClick(e);
            this.context.toggle(e);
        };
    }
    render() {
        const _a = this.props, { className, color, caret, split, nav, tag, menuItem, title } = _a, props = (0, tslib_1.__rest)(_a, ["className", "color", "caret", "split", "nav", "tag", "menuItem", "title"]);
        const ariaLabel = props["aria-label"] || "Toggle Dropdown";
        let classes = (0, classnames_1.default)(className, {
            "dropdown-item": menuItem,
            "dropdown-toggle": caret || split,
            "dropdown-toggle-split": split,
            "nav-link": nav,
        });
        const children = props.children || (0, jsx_runtime_1.jsx)("span", Object.assign({ className: "sr-only" }, { children: ariaLabel }), void 0);
        let Tag;
        const tagProps = Object.assign({}, props);
        if (nav && !tag) {
            Tag = "a";
            tagProps.href = "#";
        }
        else if (!tag) {
            Tag = "button";
            classes = (0, classnames_1.default)(classes, "btn btn-default");
            tagProps.color = color;
        }
        else {
            Tag = tag;
        }
        if (this.context.inNavbar) {
            return ((0, jsx_runtime_1.jsx)(Tag, Object.assign({}, props, { className: classes, onClick: this.onClick, "aria-expanded": this.context.isOpen, children: children, role: menuItem ? "menuitem" : undefined }), void 0));
        }
        return ((0, jsx_runtime_1.jsx)(react_popper_1.Reference, { children: ({ ref }) => ((0, jsx_runtime_1.jsx)(Tag, Object.assign({ className: classes, type: Tag === "button" ? "button" : undefined, onClick: this.onClick, "aria-expanded": this.context.isOpen, ref: ref, role: menuItem ? "menuitem" : undefined, disabled: props.disabled, title: title }, { children: children }), void 0)) }, void 0));
    }
}
exports.default = DropdownToggle;
DropdownToggle.defaultProps = {
    "aria-haspopup": true,
    color: "secondary",
};
DropdownToggle.contextTypes = {
    isOpen: prop_types_1.default.bool.isRequired,
    toggle: prop_types_1.default.func.isRequired,
    inNavbar: prop_types_1.default.bool.isRequired,
};
