"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const styled_components_1 = (0, tslib_1.__importDefault)(require("styled-components"));
const ListItem = styled_components_1.default.li `
	overflow: hidden;
	position: relative;
`;
const InfiniteListItem = ({ children, className, tag, onFocus, onClick, onKeyDown, itemId, tabIndex = 0, }) => {
    const onFocusCallback = React.useCallback(() => onFocus === null || onFocus === void 0 ? void 0 : onFocus(itemId), [onFocus, itemId]);
    const onClickCallback = React.useCallback(() => onClick === null || onClick === void 0 ? void 0 : onClick(itemId), [onClick, itemId]);
    const onKeyDownCallback = React.useCallback((e) => onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(e, itemId), [onKeyDown, itemId]);
    return ((0, jsx_runtime_1.jsx)(ListItem, Object.assign({ as: tag, tabIndex: tabIndex, className: className, role: "listitem", onFocus: onFocusCallback, onClick: onClickCallback, onKeyDown: onKeyDownCallback }, { children: children }), void 0));
};
exports.default = React.memo(InfiniteListItem);
