"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const react_dom_1 = require("react-dom");
const react_draggable_elements_1 = (0, tslib_1.__importDefault)(require("react-draggable-elements"));
const lodash_1 = (0, tslib_1.__importDefault)(require("lodash"));
const classnames_1 = (0, tslib_1.__importDefault)(require("classnames"));
const utils_1 = require("../utils");
class LookupDialog extends React.Component {
    constructor() {
        super(...arguments);
        this.draggableContainer = null;
        this.containerRef = React.createRef();
        this.handleClickOutside = (event) => {
            this.props.close(event);
        };
        this.focusFirstInput = () => {
            var _a;
            const input = lodash_1.default.find((_a = this.containerRef.current) === null || _a === void 0 ? void 0 : _a.querySelectorAll("input"), (input) => input.type !== "hidden");
            input && input.focus();
        };
        this.onKeyDown = (e) => {
            const eventKey = e.key;
            switch (eventKey) {
                case "Escape":
                    this.props.close(e);
                    break;
                case "Tab":
                    if (!(0, utils_1.isDescendant)(this.containerRef.current, e.target)) {
                        e.preventDefault();
                        this.focusFirstInput();
                    }
                    break;
            }
        };
    }
    componentDidMount() {
        if (this.props.isDraggable) {
            this.draggableContainer = (this.props.portalTarget
                ? this.props.portalTarget.charAt(0) === "."
                    ? document.getElementsByClassName(this.props.portalTarget.substring(1))[0]
                    : document.getElementById(this.props.portalTarget.substring(1))
                : document.body);
        }
        this.focusFirstInput();
    }
    render() {
        const _a = this.props, { close, eventTypes, outsideClickIgnoreClass, preventDefault, stopPropagation, disableOnClickOutside, enableOnClickOutside, position, isDraggable, dragHandle, children, portalTarget, ariaLabelledBy } = _a, rest = (0, tslib_1.__rest)(_a, ["close", "eventTypes", "outsideClickIgnoreClass", "preventDefault", "stopPropagation", "disableOnClickOutside", "enableOnClickOutside", "position", "isDraggable", "dragHandle", "children", "portalTarget", "ariaLabelledBy"]);
        const defaultPosition = {
            x: position.x,
            y: position.y + 5,
        };
        if (isDraggable) {
            const DraggableDialog = ((0, jsx_runtime_1.jsx)(react_draggable_elements_1.default, Object.assign({ handle: dragHandle, defaultPosition: defaultPosition }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ ref: this.containerRef, role: "dialog", onKeyDown: this.onKeyDown, "aria-labelledby": ariaLabelledBy, style: {
                        minWidth: 100,
                        minHeight: 100,
                        background: "#fff",
                        zIndex: 99999,
                        boxShadow: "2px 7px 24px 2px rgba(144,143,143,.8)",
                        opacity: 1,
                    } }, rest, { children: children }), void 0) }), void 0));
            return this.draggableContainer
                ? (0, react_dom_1.createPortal)(DraggableDialog, this.draggableContainer)
                : DraggableDialog;
        }
        return ((0, jsx_runtime_1.jsxs)(React.Fragment, { children: [(0, jsx_runtime_1.jsx)("div", { className: "popup-overlay", style: { zIndex: 1055 } }, void 0), (0, jsx_runtime_1.jsx)("div", Object.assign({ className: (0, classnames_1.default)("popup-container ignore-react-onclickoutside", this.props.className), ref: this.containerRef, onKeyDown: this.onKeyDown, role: "dialog", "aria-labelledby": ariaLabelledBy, style: {
                        top: 0,
                        left: 0,
                        opacity: 1,
                        zIndex: 1056,
                    } }, { children: children }), void 0)] }, void 0));
    }
}
exports.default = LookupDialog;
LookupDialog.defaultProps = {
    dragHandle: ".popup-container",
    className: "popup-container dialog",
};
