"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const react_overlays_1 = require("react-overlays");
const Popup_styles_1 = require("./Popup.styles");
const usePopper_1 = (0, tslib_1.__importDefault)(require("react-overlays/usePopper"));
const react_draggable_elements_1 = require("react-draggable-elements");
Popup.defaultProps = {
    isDraggable: true,
    className: "popup__dialog",
    backdropClassName: "popup__overlay",
    handle: ".popup__dialog",
    show: true,
    targetNode: undefined,
    placement: undefined,
    onHide: undefined,
    "aria-labelledby": undefined,
    autoFocus: true,
    allowOverlapOnOverflow: true,
};
function Popup(props) {
    var _a, _b;
    const { handle, children, "aria-labelledby": ariaLabelledBy, isDraggable, show, className, backdropClassName, targetNode, placement, onHide, autoFocus, allowOverlapOnOverflow, backdrop, enforceFocus, } = props;
    const [modalElement, setModalElement] = React.useState();
    const renderBackdrop = React.useMemo(() => (props) => {
        return (0, jsx_runtime_1.jsx)("div", Object.assign({ className: backdropClassName, style: Popup_styles_1.styles.backdrop }, props), void 0);
    }, [backdropClassName]);
    const renderDialog = React.useMemo(() => (props) => {
        return ((0, jsx_runtime_1.jsx)(react_draggable_elements_1.PositionedDraggable, Object.assign({ disabled: !isDraggable, handle: handle, bounds: "html" }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({}, props, { children: children }), void 0) }), void 0));
    }, [isDraggable, handle, children]);
    const popperStyle = (_b = (_a = (0, usePopper_1.default)(targetNode, modalElement, {
        placement: placement === false ? undefined : placement,
        modifiers: allowOverlapOnOverflow
            ? [{ name: "preventOverflow", options: { altAxis: true } }]
            : undefined,
    })) === null || _a === void 0 ? void 0 : _a.styles) === null || _b === void 0 ? void 0 : _b.popper;
    return ((0, jsx_runtime_1.jsx)(react_overlays_1.Modal, { ref: (handle) => setModalElement(handle === null || handle === void 0 ? void 0 : handle.dialog), "aria-labelledby": ariaLabelledBy, className: className, renderBackdrop: renderBackdrop, renderDialog: renderDialog, onHide: onHide, show: show, autoFocus: autoFocus, backdrop: backdrop, enforceFocus: enforceFocus, style: Object.assign(Object.assign({}, Popup_styles_1.styles.dialog), (placement === false ? {} : targetNode ? popperStyle : Popup_styles_1.styles.centerToScreen)) }, void 0));
}
exports.default = Popup;
