"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const React = (0, tslib_1.__importStar)(require("react"));
const styled_components_1 = (0, tslib_1.__importDefault)(require("styled-components"));
const spinnerMap = {
    fade: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/FadeLoader")))),
    clip: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/ClipLoader")))),
    bar: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/BarLoader")))),
    sync: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/SyncLoader")))),
    pulse: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/PulseLoader")))),
    bounce: React.lazy(() => Promise.resolve().then(() => (0, tslib_1.__importStar)(require("react-spinners/BounceLoader")))),
};
const SpinnerContainer = styled_components_1.default.div `
	position: relative;
	justify-content: center;
	flex: 0 0 auto;
	display: flex;
	align-items: center;
	padding: 10px;
`;
const SpinnerLabel = styled_components_1.default.div `
	margin-left: 10px;
`;
const Spinner = (_a) => {
    var { type, label } = _a, props = (0, tslib_1.__rest)(_a, ["type", "label"]);
    const Loader = spinnerMap[type];
    return ((0, jsx_runtime_1.jsx)(React.Suspense, Object.assign({ fallback: "" }, { children: (0, jsx_runtime_1.jsxs)(SpinnerContainer, { children: [(0, jsx_runtime_1.jsx)(Loader, Object.assign({}, props), void 0), label && (0, jsx_runtime_1.jsx)(SpinnerLabel, { children: label }, void 0)] }, void 0) }), void 0));
};
Spinner.defaultProps = {
    type: "clip",
    color: "#2180c0",
};
exports.default = Spinner;
