import * as React from "react";
import { Options } from "@popperjs/core";
export interface DateTimePickerProps {
    id?: string;
    name?: string;
    value?: Date | string;
    defaultValue?: Date | string;
    viewDate?: Date | string;
    dateFormat?: "L" | "LL" | "LLL" | "LLLL" | "LT" | "LTS" | boolean;
    timeFormat?: "LT" | "LTS" | boolean;
    locale?: string;
    onChange?: (e: any) => any;
    onBlur?: (e: any) => any;
    viewMode?: "date" | "time" | "datetime";
    className?: string;
    minDate?: Date | string;
    maxDate?: Date | string;
    disabled?: boolean;
    required?: boolean;
    closeOnSelect?: boolean;
    allowSameDay?: boolean;
    todayButton?: boolean;
    portalPopupTo?: React.ReactNode;
    inline?: boolean;
    popperPlacement?: Options["placement"];
}
export default class DateTimePicker extends React.Component<DateTimePickerProps> {
    static defaultProps: {
        locale: string;
    };
    showTimeSelect: boolean;
    showTimeSelectOnly: boolean;
    currentNls: null;
    dateFormatId: string;
    timeFormatId: string;
    popperContainer: any;
    constructor(props: any);
    render(): JSX.Element;
}
