import * as React from "react";
import PropTypes from "prop-types";
import DropdownToggle from "./DropdownToggle";
import DropdownItem from "./DropdownItem";
export interface DropdownProps {
    disabled?: boolean;
    direction?: "up" | "down" | "left" | "right";
    group?: boolean;
    isOpen?: boolean;
    nav?: boolean;
    active?: boolean;
    addonType?: "prepend" | "append" | boolean;
    size?: string;
    tag?: string;
    toggle: (e?: any) => void;
    className?: string;
    inNavbar?: boolean;
    setActiveFromChild?: boolean;
    parentToggle?: (e?: any) => void;
}
declare class Dropdown extends React.Component<DropdownProps> {
    static Toggle: typeof DropdownToggle;
    static Menu: React.FunctionComponent<import("./DropdownMenu").DropdownMenuProps>;
    static Item: typeof DropdownItem;
    static defaultProps: {
        isOpen: boolean;
        direction: string;
        nav: boolean;
        active: boolean;
        addonType: boolean;
        inNavbar: boolean;
        setActiveFromChild: boolean;
    };
    static childContextTypes: {
        toggle: PropTypes.Validator<(...args: any[]) => any>;
        isOpen: PropTypes.Validator<boolean>;
        direction: PropTypes.Validator<string>;
        inNavbar: PropTypes.Validator<boolean>;
    };
    getChildContext(): {
        toggle: (e: any) => void;
        isOpen: boolean | undefined;
        direction: "right" | "left" | "up" | "down" | undefined;
        inNavbar: boolean | undefined;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    getContainer: () => Element;
    addEvents: () => void;
    removeEvents: () => void;
    handleDocumentClick: (e: any) => void;
    handleKeyDown: (e: any) => void;
    handleProps: () => void;
    toggle: (e: any) => any;
    render(): JSX.Element;
}
export default Dropdown;
