import * as React from "react";
import PropTypes from "prop-types";
export interface DropdownItemProps {
    active?: boolean;
    disabled?: boolean;
    divider?: boolean;
    tag?: React.ComponentType | keyof JSX.IntrinsicElements;
    header?: boolean;
    onClick?: (event?: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    className?: string;
    toggle?: boolean;
    innerRef?: any;
    type?: string;
    href?: string;
}
export default class DropdownItem extends React.Component<DropdownItemProps> {
    static defaultProps: {
        tag: string;
        toggle: boolean;
    };
    static contextTypes: {
        toggle: PropTypes.Requireable<(...args: any[]) => any>;
    };
    onItemClick: (e: any) => void;
    get role(): "menuitem" | "presentation";
    render(): JSX.Element;
}
