import * as React from "react";
import PropTypes from "prop-types";
export interface DropdownToggleProps {
    caret?: boolean;
    color?: string;
    className?: string;
    disabled?: boolean;
    onClick?: (event: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    "aria-haspopup"?: boolean;
    split?: boolean;
    tag?: React.ComponentType | keyof JSX.IntrinsicElements;
    nav?: boolean;
    menuItem?: boolean;
    title?: HTMLElement["title"];
}
export default class DropdownToggle extends React.Component<DropdownToggleProps> {
    static defaultProps: {
        "aria-haspopup": boolean;
        color: string;
    };
    static contextTypes: {
        isOpen: PropTypes.Validator<boolean>;
        toggle: PropTypes.Validator<(...args: any[]) => any>;
        inNavbar: PropTypes.Validator<boolean>;
    };
    onClick: (e: any) => void;
    render(): JSX.Element;
}
