import * as React from "react";
export interface InfiniteListProps {
    id?: string;
    next?: () => void;
    hasMore?: boolean;
    endMessage?: React.ReactNode;
    height?: string | number;
    scrollableTarget?: React.ReactNode;
    hasChildren?: boolean;
    onScroll?: (event?: any) => void;
    dataLength: number;
    className?: string;
    listClassName?: string;
    loadButtonClassName?: string;
    spinnerColor?: string;
    tag?: keyof JSX.IntrinsicElements;
    keyboardNavigationEnabled?: boolean;
    keyboardNavigationPageSize?: number;
}
declare type State = {
    dataLength: number;
    showLoader: boolean;
    actionTriggered: boolean;
    canScroll: boolean;
};
export default class InfiniteList extends React.Component<InfiniteListProps, State> {
    static Item: React.NamedExoticComponent<React.PropsWithChildren<import("./InfiniteListItem").InfiniteListItemProps>>;
    private el;
    private _infScroll;
    private _scrollableNode;
    private listRef;
    private keyboardHandlers;
    static defaultProps: Partial<InfiniteListProps>;
    constructor(props: InfiniteListProps);
    getScrollableTarget: () => HTMLElement | null;
    private updateCanScroll;
    private next;
    isElementAtBottom(target: HTMLElement): boolean;
    onScrollListener: (event: any) => void;
    private throttledOnScrollListener;
    static getDerivedStateFromProps(props: any, state: any): {
        dataLength: any;
        showLoader: boolean;
        actionTriggered: boolean;
    } | null;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
