import * as React from "react";
import type { ModalProps } from "react-overlays/Modal";
import { Options as PopperOptions } from "@popperjs/core";
export declare type Placement = PopperOptions["placement"];
export interface PopupProps {
    isDraggable?: boolean;
    className: ModalProps["className"];
    backdropClassName?: string;
    handle?: string;
    show: ModalProps["show"];
    targetNode?: HTMLElement;
    placement: Placement | false;
    onHide: ModalProps["onHide"];
    "aria-labelledby": string;
    autoFocus: ModalProps["autoFocus"];
    allowOverlapOnOverflow?: boolean;
    backdrop?: ModalProps["backdrop"];
    enforceFocus?: ModalProps["enforceFocus"];
}
declare function Popup(props: React.PropsWithChildren<PopupProps>): JSX.Element;
declare namespace Popup {
    var defaultProps: {
        isDraggable: boolean;
        className: string;
        backdropClassName: string;
        handle: string;
        show: boolean;
        targetNode: undefined;
        placement: undefined;
        onHide: undefined;
        "aria-labelledby": undefined;
        autoFocus: boolean;
        allowOverlapOnOverflow: boolean;
    };
}
export default Popup;
